#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/wait.h>


int main ()
{
	int goals[20];
	int max = 0;
	int i;
	for (i=0; i<20; ++i) {
		goals[i] = 0;
	}
	for (i=0; i<100; ++i) {
		pid_t pid = fork ();
		if (pid < 0) {
			perror ("fork");
			exit (1);
		}
		if (pid) {
			/* Parent */
			int status;
			int ret = wait (&status);
			if (ret < 0) {
				perror ("wait");
				exit (1);
			}
			if (WIFEXITED(status)) {
				int goal = WEXITSTATUS(status);
				if (goal < 20) {
					if (goal > max)
						max = goal;
					goals[goal]++;
				} else {
					fprintf (stderr, "%d goals??\n", goal);
				}
			} else {
				fprintf (stderr, "Strange termination\n");
			}
		} else {
			execlp ("goals", "goals", "1", "1", 0);
			perror ("execlp");
			exit (100);
		}
	}
	for (i=0; i<=max; ++i) {
		printf ("%2d  %2d\n", i, goals[i]);
	}
	return 0;
}
